{
  lib,
  craneLib,
  ffmpeg,
  libadwaita,
  mold-wrapped,
  pkg-config,
  wrapGAppsHook4,
  zenity,
}:
let
  cargoToml = lib.importTOML ./Cargo.toml;
in
craneLib.buildPackage {
  pname = cargoToml.package.name;
  inherit (cargoToml.package) version;

  src = craneLib.cleanCargoSource ./.;

  nativeBuildInputs = [
    mold-wrapped
    pkg-config
    wrapGAppsHook4
  ];

  buildInputs = [ libadwaita ];

  RUSTFLAGS = "-C link-arg=-fuse-ld=mold";

  doCheck = false;

  preFixup = ''
    gappsWrapperArgs+=(
      --prefix PATH : ${
        lib.makeBinPath [
          ffmpeg
          zenity
        ]
      }
    )
  '';

  meta = with lib; {
    mainProgram = cargoToml.package.name;
    description = "simple tool to convert, upload, and embed videos to zipline";
    homepage = "https://git.uku3lig.net/uku/tyrolienne";
    license = licenses.mpl20;
    platforms = platforms.unix;
  };
}
